package com.asda.android.app.account.datasource

import android.content.Context
import com.asda.android.R
import com.asda.android.app.account.parser.AccountFragmentTagParser
import com.asda.android.singleprofile.features.account.view.PersonalDetailsFragment

/**
 * retrieves title from fragment tag
 */
class GetFragmentTitleDataSource {

    fun execute(context: Context?, tag: String?): String? {
        context?.let {
            return when (tag) {
                PersonalDetailsFragment.TAG -> context.getString(R.string.account_setting_personal_detail)
                AccountFragmentTagParser.SIGN_IN_DETAILS_FRAGMENT_TAG -> context.getString(R.string.account_setting_sign_in_detail)
                AccountFragmentTagParser.PERMISSION_CENTER_FRAGMENT_TAG -> context.getString(R.string.account_setting_permission_center)
                else -> null
            }
        }
        return null
    }
}
