package com.asda.android.app.account.manager

import android.app.Activity
import android.content.Context
import android.view.View
import com.asda.android.analytics.AsdaAnalyticsEvent
import com.asda.android.analytics.Tracker
import com.asda.android.analytics.constants.Anivia
import com.asda.android.app.account.view.BaseAccountActivity
import com.asda.android.app.settings.detail.view.SettingsFragment
import com.asda.android.base.interfaces.IAccountManager

class AccountManager : IAccountManager {

    override fun navigateToSettings(context: Context, view: View, locationKeyForTracking: String?) {
        BaseAccountActivity.launchAccountActivity(context as Activity?, SettingsFragment.TAG, view)
        Tracker.get().trackEvent(
              AsdaAnalyticsEvent(Anivia.SECTION_TAP)
                    .putString(Anivia.LOCATION_KEY, locationKeyForTracking)
                    .putString(Anivia.SECTION_NAME_KEY, "settings")
        )
    }
}
