package com.asda.android.app.account.parser


import com.asda.android.app.account.parser.AccountFragmentTagParser.Companion.PERMISSION_CENTER_FRAGMENT_TAG
import com.asda.android.base.core.parser.IParser
import com.asda.android.base.core.response.BaseStateResponse
import com.asda.android.base.core.statemanagement.type.State
import com.asda.android.base.core.web.constants.WebConstants.ACTION_OPEN_URL
import com.asda.android.base.core.web.model.WebViewEventModel


/**
 * Returns the the url which match with the provided input
 */
class OpenUrlParser : IParser<BaseStateResponse<WebViewEventModel>, String?> {

    override fun parse(input: BaseStateResponse<WebViewEventModel>): String? {
        input.getData()?.let {
            if (input.getState() == State.SUCCESS && it.action == ACTION_OPEN_URL) {
                when (it.pageName) {
                    PERMISSION_CENTER_FRAGMENT_TAG -> return it.metadata
                }
            }
        }
        return null
    }

}
