package com.asda.android.app.account.singleprofile.view

import android.app.Dialog
import android.content.Context
import android.view.View
import android.widget.TextView
import com.asda.android.R
import com.asda.android.base.core.view.ui.DialogHelper

/**
 *
 * @param onCreateAccount - Click handler for onCreateAccount
 * @param onCloseDialog - Click handler for dialog close button click (this includes btnTryAnotherPostcode)
 * @param context - Context must of of an Activity or a Fragment. NOTE: Application Context will not work.
 * @return - Returns Dialog instance that the caller must keep so it can be closed at a later stage.
 */
public fun show(
        postCode: String,
        onCreateAccount: View.OnClickListener,
        onTryAnother: View.OnClickListener,
        onCloseDialog: View.OnClickListener,
        context: Context): Dialog? {

    val clickListenersMap = mutableMapOf<Int, View.OnClickListener>()
    clickListenersMap[R.id.ibClose] = onCloseDialog
    clickListenersMap[R.id.btnTryAnotherPostcode] = onTryAnother
    clickListenersMap[R.id.btnCreateAccount] = onCreateAccount

    var dlg : Dialog? = DialogHelper.displayCustomDialog(R.layout.postcode_badnews, clickListenersMap, null, true, context)
    var tvWeDontOperateIn: TextView? = dlg?.findViewById(R.id.tvWeDontOperateIn)
    tvWeDontOperateIn?.text = context.getString(R.string.we_dont_operate_in, postCode)

    return dlg
}
