package com.asda.android.app.account.singleprofile.view

import android.app.Dialog
import android.content.Context
import android.text.TextUtils
import android.view.View
import android.widget.TextView
import com.asda.android.R
import com.asda.android.base.core.view.ui.DialogHelper

fun show(
        postCodeGiven: String,
        storeName: String,
        storeDistance: String,
        storeAddress: String,
        postCodeSuggested: String,
        onCreateAccount: View.OnClickListener,
        onTryAnother: View.OnClickListener,
        onCloseDialog: View.OnClickListener,
        context: Context): Dialog? {

    val clickListenersMap = mutableMapOf<Int, View.OnClickListener>()
    clickListenersMap[R.id.ibClose] = onCloseDialog
    clickListenersMap[R.id.btnTryAnotherPostcode] = onTryAnother
    clickListenersMap[R.id.btnCreateAccount] = onCreateAccount



    var dlg : Dialog? = DialogHelper.displayCustomDialog(R.layout.postcode_goodnews_candc, clickListenersMap, null, true, context)
    var tvWeDontDeliverTo: TextView? = dlg?.findViewById(R.id.tvWeDontDeliverTo)
    var tvStoreNameAndDistance: TextView? = dlg?.findViewById(R.id.tvStoreNameAndDistance)
    var tvStoreContact: TextView? = dlg?.findViewById(R.id.tvStoreContact)

    tvWeDontDeliverTo?.setText(context.getString(R.string.we_dont_deliver_ubt_cnc_available, postCodeGiven))
    if (!TextUtils.isEmpty(storeDistance)) {
        tvStoreNameAndDistance?.setText(context.getString(R.string.store_name_and_distance, storeName, storeDistance))
    } else {
        tvStoreNameAndDistance?.setText(storeName)
    }
    tvStoreContact?.setText(context.getString(R.string.contact_address_and_postcode, storeAddress, postCodeSuggested))

    return dlg
}
