package com.asda.android.app.base

import android.content.Context
import android.content.SharedPreferences
import androidx.annotation.NonNull

class SiteSpectPreferences {

    companion object {
        private const val SHARED_PREF_SITESPECT = "sitespect_abtesting_module"
        private const val PREF_SITESPECT_USER_ID = "DYN_USER_ID"
    }

    private fun getSharedPreferences(context: Context?): SharedPreferences? {
        return context?.getSharedPreferences(SHARED_PREF_SITESPECT, Context.MODE_PRIVATE)
    }

    fun removeSiteSpectUserID(context: Context?) {
        getSharedPreferences(context)?.edit()?.remove(SHARED_PREF_SITESPECT)?.apply()
    }

    fun setSiteSpectUserID(context: Context?, userID: String?) {
        if (userID?.isNotBlank() == true && userID.isNotEmpty()) {
            getSharedPreferences(context)?.edit()?.putString(PREF_SITESPECT_USER_ID, userID)?.apply()
        }
    }

    @NonNull
    fun getSiteSpectUserID(context: Context?): String {
        return getSharedPreferences(context)?.getString(PREF_SITESPECT_USER_ID, "") ?: ""
    }

}
