package com.asda.android.app.beforeyougo.formatter

import com.asda.android.base.core.formatter.IFormatter
import com.asda.android.service.base.CartManager

abstract class BaseCartItemsFormatter : IFormatter<CartManager?, String> {
    private val itemSeparator = "|"
    private val defaultOutput = ""
    override fun format(input: CartManager?): String {
        input?.let {
            val ids = getIds(it)
            ids?.let {
                return it.filterNotNull().distinct().joinToString(itemSeparator)
            }
        }
        return defaultOutput
    }

    abstract fun getIds(input: CartManager): List<String?>?
}
