package com.asda.android.app.beforeyougo.formatter

import com.asda.android.base.core.formatter.IFormatter
import com.asda.android.restapi.service.data.cms.Content
import com.asda.android.restapi.service.data.cms.Personalization

class PersonalizationContentFormatter : IFormatter<Array<Content?>?, List<Personalization>> {
    override fun format(input: Array<Content?>?): List<Personalization> {
        val personalizationList = mutableListOf<Personalization>()
        input?.let {
            it.forEach { content ->
                run {
                    content?.let {
                        if (it is Personalization) {
                            personalizationList.add(it)
                        } else {
                            personalizationList.addAll(format(content.contents))
                        }
                    }
                }
            }
        }
        return personalizationList
    }
}
