package com.asda.android.app.beforeyougo.parser

import android.app.Application
import androidx.annotation.VisibleForTesting
import com.asda.android.base.core.AsdaBaseUtils
import com.asda.android.restapi.service.data.cms.Personalization

class RecordsPerPageParser {
    fun parse(input: Personalization?, application: Application): String? {
        val deviceType = getDeviceName(application)
        var productCount: String? = null
        input?.let {
            run loop@{
                it.recipeProductcount?.forEach { recipeProductCount ->
                    recipeProductCount?.name?.let {
                        if (it.contains(deviceType, true)) {
                            productCount = recipeProductCount.productCount
                            return@loop
                        }
                    }
                }
            }
            productCount = productCount ?: it.recordsPerPage
        }
        return productCount
    }

    @VisibleForTesting
    fun getDeviceName(application: Application): String {
        return if (AsdaBaseUtils.isTablet(application)) {
            "Tablet"
        } else {
            "Mobile"
        }
    }
}
