package com.asda.android.app.beforeyougo.parser

import com.asda.android.base.core.parser.IParser
import com.asda.android.abtestingframework.implementation.sitespect.metrics.SitespectP13NMetrics
import com.asda.android.app.main.ApplicationComponent

class VariationGroupParser:IParser<ApplicationComponent?, Int> {
    override fun parse(input: ApplicationComponent?): Int {
        input?.let {
            val variationGroup = it
                  .sitespectAbTestEngine?.getVariationId(SitespectP13NMetrics.P13N_BYG_CAMPAIGN_ID.toString())
            variationGroup?.let { variationGroupId ->
                return try {
                    Integer.parseInt(variationGroupId)
                } catch (exception: NumberFormatException) {
                    SitespectP13NMetrics.P13N_BYG_VARIATION_GROUP
                }
            }
        }
        return SitespectP13NMetrics.P13N_BYG_VARIATION_GROUP
    }
}
