package com.asda.android.app.beforeyougo.repository

import com.asda.android.analytics.constants.Anivia
import com.asda.android.analytics.events.ApiErrorEvent
import com.asda.android.app.beforeyougo.model.APIErrorEventModel
import com.asda.android.restapi.service.base.IAuthentication
import com.asda.android.service.base.Authentication

class BygErrorTrackerRepository : BaseRepository() {
    fun execute(event: APIErrorEventModel) {
        val errorEvent = ApiErrorEvent.createResponseEvent(event.apiEndPoint
              ?: "", event.errorCode, event.errorMessage
              ?: "", System.currentTimeMillis().toString(), Anivia.PV_BEFORE_YOU_GO, event.errorMessage
              ?: "")
        errorEvent.putString(Anivia.CUSTOMER_ID_KEY, getAuthentication()?.profileId ?: "")
        getTracker()?.trackEvent(errorEvent)
    }

    fun getAuthentication(): IAuthentication? {
        return Authentication.getInstance()
    }
}
