package com.asda.android.app.bookslot

import android.content.Context
import androidx.annotation.MainThread
import com.asda.android.restapi.search.model.AsdaSearchData
import com.asda.android.restapi.search.model.SearchData
import com.asda.android.search.data.provider.SuggestionProvider
import java.util.*
import kotlin.collections.ArrayList

class ClickAndCollectCitiesSuggestionProvider : SuggestionProvider<AsdaSearchData> {

    init {
        updateUpperCasedCities()
    }

    @MainThread
    override fun getExtraSuggestions(context: Context, query: String?, callback: SuggestionProvider.OnFinished<AsdaSearchData>?) {
        //Implementation Not required
    }

    override fun getSuggestions(query: String?): List<AsdaSearchData> {
        var query = query
        query = query?.toUpperCase(Locale.UK) ?: ""
        val suggestions = arrayOfNulls<String>(MAX_SUGGESTIONS)
        var suggestionCount = 0
        mAllCitiesUpper?.let {
            for (i in it.indices) {
                if (it[i].startsWith(query)) {
                    suggestions[suggestionCount] = mAllCities[i]
                    suggestionCount++
                }
                if (suggestionCount == MAX_SUGGESTIONS) {
                    break
                }
            }
        }
        val temp = ArrayList<AsdaSearchData>(suggestionCount)
        for (i in 0 until suggestionCount) {
            temp.add(
                  AsdaSearchData(
                        suggestions[i],
                        SearchData.SearchType.SEARCH_TYPE_SUGGESTION,
                        null,
                        AsdaSearchData.TYPE_DEFAULT
                  )
            )
        }
        return temp
    }

    companion object {
        private var mAllCities: Array<String> = arrayOf("Aberdare", "Aberdeen", "Accrington",
              "Alloa", "Andover", "Antrim", "Arbroath", "Ardrossan", "Armadale", "Ashford",
              "Ashington", "Ashton Under Lyne", "Aylesbury", "Ayr", "Balby", "Ballyclare",
              "Bangor", "Barking", "Barnsley", "Barrhead", "Barrow in Furness", "Basildon",
              "Basingstoke", "Batley", "Belfast", "Benwell", "Beverley", "Bexley Heath",
              "Bideford", "Biggleswade", "Billingham", "Birkenhead", "Birmingham",
              "Bishop Auckland", "Bishopbriggs", "Blackburn", "Blackpool", "Blackwood",
              "Bloxwich", "Blyth", "Bodmin", "Boldon Colliery", "Bolton", "Boston", "Bournemouth",
              "Bradford", "Bridgend", "Bridgwater", "Brierley Hill", "Brighton", "Bristol",
              "Broad Heath", "Broadstairs", "Bromborough", "Bromsgrove", "Burnley",
              "Burton on Trent", "Bury", "Bury St Edmunds", "Caernarfon", "Caerphilly",
              "Caldicot", "Cambridge", "Cannock", "Canterbury", "Cardiff", "Carlisle",
              "Castleford", "Chatham", "Cheadle Hulme", "Chelmsford", "Cheltenham", "Cheshire",
              "Chester", "Chesterfield", "Chorley", "Clapham", "Clevedon", "Clydebank", "Coalville",
              "Coatbridge", "Colchester", "Coleraine", "Colne", "Conisbrough", "Cookstown", "Corby",
              "Coseley", "Coventry", "Cramlington", "Crawley", "Crewe", "Croydon", "Cumnock",
              "Cwmbran", "Dagenham", "Darlington", "Dartford", "Darwen", "Derby", "Dewsbury",
              "Doncaster", "Dover", "Downpatrick", "Dudley", "Dumbarton", "Dunbar", "Dundee",
              "Dundonald", "Dunfermline", "Dunstable", "Durham", "Eastbourne", "East Finchley",
              "Eastleigh", "Ebbw Vale", "Eccles", "Edgware", "Edinburgh", "Edlington", "Elgin",
              "Enfield", "Enniskillen", "Epping", "Falkirk", "Falmouth", "Fareham", "Farnborough",
              "Farnworth", "Feltham", "Fife", "Fleetwood", "Flint", "Folkestone", "Forfar",
              "Fraserburgh", "Frome", "Galashiels", "Garston", "Gateshead", "Gillingham",
              "Girvan", "Glasgow", "Glenrothes", "Gloucester", "Golborne", "Goldthorpe", "Goole",
              "Gorseinon", "Gosforth", "Gosport", "Grangemouth", "Grantham", "Gravesend",
              "Greater London", "Great Yarmouth", "Greenhithe", "Grimethorpe", "Grimsby",
              "Hailsham", "Halesowen", "Halifax", "Hamilton", "Harlow", "Harrogate", "Harrow",
              "Harrow and Wealdstone", "Hartlepool", "Harwich", "Hatfield", "Havant", "Hayle",
              "Hebburn", "Hemel Hempstead", "Hereford", "Heybridge", "High Barnet", "Highbridge",
              "Highgate", "High Wycombe", "Hinckley", "Hindley", "Hitchin", "Hoddesdon",
              "Holyhead", "Hounslow", "Huddersfield", "Hull", "Huntly", "Hyde", "Ilford",
              "Inverness", "Ipswich", "Irvine", "Keighley", "Kendal", "Kettering", "Kidderminster",
              "Kilkeel", "Kilmarnock", "Kingshill", "Kings Lynn", "Kingston Upon Thames",
              "Kirkcaldy", "Lancaster", "Lancing", "Langley Mill", "Larkhall", "Larne",
              "Leamington Spa", "Leeds", "Leek", "Leicester", "Leigh", "Leith", "Lemington",
              "Leyland", "Leyton", "Lincoln", "Liverpool", "Livingston", "Llandudno", "Llanelli",
              "Llangefni", "Llantrisant", "Loanhead", "London", "Lower Earley", "Lowestoft",
              "Luton", "Lutterworth", "Maidstone", "Malton", "Manchester", "Mansfield",
              "Market Drayton", "Market Weighton", "Melksham", "Merthyr Tydfil", "Middlesbrough",
              "Milton Keynes", "Mitcham", "Moorthorpe", "Morecambe", "Morley", "Motherwell",
              "Newark", "Newcastle Upon Tyne", "Newmains", "Newmarket", "New Ollerton",
              "Newport", "Newquay", "Newton Abbot", "Newton Heath", "Newton Mearns",
              "Newtownards", "Northallerton", "Northampton", "Northolt", "North Shields",
              "Norwich", "Nottingham", "Nuneaton", "Oldbury", "Oldham", "Omagh", "Otley", "Oxford",
              "Paignton", "Paisley", "Peckham", "Pembroke Dock", "Pershore", "Perth",
              "Peterborough", "Peterhead", "Peterlee", "Plymouth", "Pontefract", "Poole",
              "Portadown", "Portsmouth", "Poynton", "Preston", "Pwllheli", "Queensferry",
              "Radcliffe", "Ramsgate", "Rawtenstall", "Rayleigh", "Reading", "Redcar", "Retford",
              "Rhyl", "Rochdale", "Romford", "Rossington", "Rotherham", "Rugby", "Runcorn",
              "Rushden", "Ryhope", "Salford", "Saltburn by the Sea", "Saltney", "Scunthorpe",
              "Seaham", "Sheffield", "Shepshed", "Shipley", "Shirley", "Shoeburyness", "Shrewsbury",
              "Sittingbourne", "Skegness", "Skelmersdale", "Slough", "Small Heath", "Smethwick",
              "Soham", "Southampton", "South Harrow", "Southport", "Stafford", "Staines",
              "Stainforth", "Stanley", "Stanmore", "St Austell", "Stenhousemuir", "Stevenage",
              "St Helens", "St Leonards on Sea", "Stockport", "Stockton on Tees", "Stoke on Trent",
              "Stoneycroft", "Stowmarket", "Strabane", "Stratford Upon Avon", "Strood", "Sunderland",
              "Sutton", "Sutton Coldfield", "Sutton in Ashfield", "Swaffham", "Swanley", "Swansea",
              "Swindon", "Swinton", "Tain", "Tamworth", "Taunton", "Telford", "Thornaby",
              "Thurnscoe", "Thurrock", "Tilbury", "Tipton", "Tiptree", "Tonypandy", "Torquay",
              "Trowbridge", "Tunbridge Wells", "Tunstall", "Tweedmouth", "Twickenham", "Uttoxeter",
              "Wakefield", "Wallsend", "Walsall", "Warrington", "Waterlooville", "Watford",
              "Wath Upon Deane", "Wavertree", "Wellington", "Wembley", "Westerhope",
              "Weston Super Mare", "Weymouth", "Whitehaven", "Widnes", "Wigan", "Winsford",
              "Wisbech", "Witham", "Woking", "Wolstanton", "Wolverhampton", "Wolverton",
              "Worcester", "Workington", "Worksop", "Worsbrough", "Worthing", "Wrexham",
              "Wyke", "Wythenshawe", "Yeovil", "York")
        private var mAllCitiesUpper: Array<String>? = null
        private const val MAX_SUGGESTIONS = 20

        fun getFirstCityMatch(originalQuery: String?): String? {
            if (mAllCitiesUpper != null) {
                val query = originalQuery?.toUpperCase(Locale.UK) ?: ""
                mAllCitiesUpper?.let {
                    for (i in it.indices) {
                        if (it[i].startsWith(query)) {
                            return mAllCities[i]
                        }
                    }
                }
            }
            return originalQuery
        }

        private fun updateUpperCasedCities() {
            mAllCities.forEach { it.toUpperCase(Locale.UK) }
            mAllCitiesUpper = mAllCities
        }
    }
}
