package com.asda.android.app.bookslotv3.service

import com.asda.android.restapi.service.data.bookslotv3.*
import io.reactivex.Observable
import io.reactivex.Single
import retrofit2.http.*

interface BookSlotAPI {

    @POST("v3/slots/reserve")
    fun reserveBookSlot(@Query("apikey") token: String?,
                        @Body reserveSlotRequestV3: ReserveSlotRequestV3): Single<ReserveSlotResponseV3>

    @POST("v3/slot/view")
    fun viewSlots(@Header("is_xcatch_enabled") xCatchHeader: Boolean, @Body viewSlotRequestData: ViewSlotRequestV3): Single<ViewSlotResponseV3>


    @GET("postcode/service-eligibility/{postcode}")
    fun getServiceEligibility(@Path("postcode") postCode: String,
                              @Query("include_accesspoint_list") includeAccessPointList: Boolean? = null)
          : Single<ServiceEligibilityData>


    @GET("postcode/service-eligibility/{postcode}")
    fun getServiceEligibility(@Path("postcode") postCode: String,
                              @Query("latitude") lat: Float,
                              @Query("longitude") lon: Float): Observable<ServiceEligibilityData>


    @GET("maps/api/geocode/json")
    fun getAddressFromLatLon(@Query("latlng") latlng: String,
                             @Query("key") key: String): Observable<ReverseGeoCoderResult>

}
