package com.asda.android.app.bookslotv3.validator

import com.asda.android.restapi.service.data.SlotResponse
import com.asda.android.restapi.service.data.bookslotv3.ServiceAddress
import com.asda.android.restapi.service.data.bookslotv3.SlotInfo
import com.asda.android.restapi.service.data.cart.Cart
import com.asda.android.restapi.utils.isMatchOrBothEmpty

class BookSlotValidator {

    fun isTimeMatch(slotInfo: SlotInfo, cartSlotInfo: Cart.SlotInfo?): Boolean {
        return (slotInfo.start_time == cartSlotInfo?.startDateTime && slotInfo.end_time == cartSlotInfo?.endDateTime)
    }

    fun isTimeMatch(slotInfo: SlotInfo, bookedStartAndEndTime: Pair<String, String>): Boolean {
        return (slotInfo.start_time == bookedStartAndEndTime.first && slotInfo.end_time == bookedStartAndEndTime.second)
    }

    fun isAddressMatch(serviceAddressPresented: ServiceAddress?, fulfillmentAddress: Cart.FulfillmentAddress?): Boolean {

        return (fulfillmentAddress?.address.isMatchOrBothEmpty(serviceAddressPresented?.address_line_one) &&
              fulfillmentAddress?.address2.isMatchOrBothEmpty(serviceAddressPresented?.address_line_two) &&
              fulfillmentAddress?.city.isMatchOrBothEmpty(serviceAddressPresented?.city) &&
              fulfillmentAddress?.postalCode.isMatchOrBothEmpty(serviceAddressPresented?.postcode))
    }

    fun isAddressMatch(serviceAddressPresented: ServiceAddress?, deliveryAddress: SlotResponse.DeliveryAddress?): Boolean {

        return (deliveryAddress?.address.isMatchOrBothEmpty(serviceAddressPresented?.address_line_one) &&
              deliveryAddress?.address2.isMatchOrBothEmpty(serviceAddressPresented?.address_line_two) &&
              deliveryAddress?.city.isMatchOrBothEmpty(serviceAddressPresented?.city) &&
              deliveryAddress?.postalCode.isMatchOrBothEmpty(serviceAddressPresented?.postcode))
    }
}
