package com.asda.android.app.bookslotv3.view.activity

import android.content.Intent
import android.os.Bundle
import android.view.View
import com.asda.android.R
import com.asda.android.app.bookslotv3.view.fragment.BookSlotParentFragment
import com.asda.android.app.bookslotv3.view.fragment.BookSlotParentFragment.Companion.SWITCH_TO_CNC_TAB
import com.asda.android.base.core.view.actitivies.AsdaAppCompatActivity
import com.asda.android.utils.Utils


class BookSlotActivity : AsdaAppCompatActivity() {
    private var mLoader: View? = null

    public override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        Utils.addNewRefToLeakDetector(TAG, this)
        setContentView(R.layout.container_fragment)
        mLoader = findViewById(R.id.loading_view)
        mLoader?.visibility = View.VISIBLE
        val actionBar = supportActionBar
        actionBar?.setTitle(R.string.book_slot)

        savedInstanceState?.let {
            // if savedInstanceState != null, means it is configuration change and we
            // don't want to push the fragment again.
            mLoader?.visibility = View.GONE
        } ?: run {
            pushBookSlot(false)
        }
    }

    override fun getFragmentContainer(): Int {
        return R.id.fragment_container
    }

    public override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        popToRoot()
        pushBookSlot(true)
    }

    private fun pushBookSlot(replace: Boolean) {
        mLoader?.visibility = View.GONE
        if (intent != null) {
            //New Bookslot code
            push(BookSlotParentFragment.getInstance(
                  intent.getBooleanExtra(EXTRA_IS_EXPRESS_BANNER_CLICKED, false),
                  intent.getBooleanExtra(SWITCH_TO_CNC_TAB, false)),
                  !replace)
        }
    }

    companion object {
        private val TAG = "BookSlotActivity"
        const val EXTRA_TARGET_TAB = "tab"
        const val EXTRA_IS_RECURRING_SLOT = "is_recurring_slot"
        const val EXTRA_IS_EXPRESS_BANNER_CLICKED = "is_express_banner_clicked"
    }
}
