package com.asda.android.app.cart.repository

import com.asda.android.analytics.anivia.model.BulkParams
import com.asda.android.analytics.constants.Anivia
import com.asda.android.analytics.events.P13NImpressionEvent
import com.asda.android.app.cart.model.P13NInfoModel
import com.asda.android.restapi.service.base.IAuthentication
import com.asda.android.restapi.service.data.cms.Content
import com.asda.android.service.base.Authentication
import com.asda.android.taxonomy.features.taxonomy.repository.BaseTaxonomyRepository

class P13NImpressionTrackerRepository : BaseTaxonomyRepository() {
    fun execute(p13NInfoModel: P13NInfoModel) {
        var isPersonalizationLoaded: Boolean
        p13NInfoModel.eventModel?.let {
            isPersonalizationLoaded = java.lang.Boolean.valueOf(it.getHasPersonalization()) && Content.checkArray(it.getInfo())
            if (isPersonalizationLoaded) {
                for (bygPageViewInfo in it.getInfo()!!) {
                    if (!bygPageViewInfo?.p13nProducts.isNullOrEmpty()) {
                        val p13NImpressionEvent = P13NImpressionEvent(bygPageViewInfo!!,
                              Anivia.SECTION_TROLLEY,
                              Anivia.SECTION_TROLLEY, null, null, null, Anivia.SECTION_TROLLEY)
                        p13NImpressionEvent.putString(Anivia.CUSTOMER_ID_KEY, getAuthentication()?.profileId
                              ?: "")
                        p13NImpressionEvent.putString(Anivia.TPID, BulkParams.ANDROID)
                        getTracker().trackEvent(p13NImpressionEvent)
                    }
                }
            }

        }
    }

    fun getAuthentication(): IAuthentication? {
        return Authentication.getInstance()
    }

}
