package com.asda.android.app.cart.validator

import android.content.Context
import com.asda.android.app.cart.utils.getP13NTCampaignId
import com.asda.android.app.cart.utils.getP13NTrolleyVariationId
import com.asda.android.app.cart.utils.isP13NForTrolleyEnabled
import com.asda.android.app.settings.featureflag.FeatureSettings
import com.asda.android.base.core.validator.Validator

class CartCampaignValidator : Validator<Context>() {

    override fun isValid(context: Context): Boolean {
        return isP13NForTrolleyEnabled(context) && FeatureSettings.isP13TrolleyFeatureEnabled(context, getP13NTCampaignId(context), getP13NTrolleyVariationId(context))
    }
}
