package com.asda.android.app.checkout

import android.app.Activity
import android.content.Context
import com.asda.android.base.interfaces.ICheckoutManager
import com.asda.android.restapi.service.data.checkout.CheckoutResponse

const val TAG = "CheckoutManager"

class CheckoutManager : ICheckoutManager {
    override fun launchAddCardWrapperPresenter(activity: Activity) {
        CheckoutActivity.startCXOPresenter(activity, CheckoutController.CXO_ADD_CARD_PRESENTER, null, -1, null)
    }

    override fun launchSelectCardPresenter(context: Context, checkoutResponse: CheckoutResponse?) {
        CheckoutActivity.startCXOPresenter(context as? Activity, CheckoutController.CXO_SELECT_CARD_PRESENTER, null, -1, checkoutResponse)
    }

    override fun launchOrderDetails(context: Context, orderId: String?) {
        CheckoutActivity.startCXOPresenter(context as? Activity, CheckoutController.CXO_ORDER_DETAILS_PRESENTER, orderId, -1, null)
    }

    override fun launchFeedbackFragment(context: Context, orderId: String?, tagId: Int) {
        CheckoutActivity.startCXOPresenter(context as? Activity, CheckoutController.CXO_FEEDBACK_FRAGMENT, orderId, tagId, null)
    }
}
