package com.asda.android.app.dp.actionstates

import com.asda.android.app.dp.model.DeliveryPassItemModel
import com.asda.android.app.model.CardCheckoutModel

sealed class CreditCardExistsActionState {
    object Loading : CreditCardExistsActionState()
    data class Loaded(
        val response: CardCheckoutModel,
        val deliveryPassPromoId: String?,
        val dpModel: DeliveryPassItemModel?,
        val isFreeTrial: Boolean
    ) : CreditCardExistsActionState()

    data class Error(val error: Throwable) : CreditCardExistsActionState()
}
