package com.asda.android.app.dp.actionstates

import com.asda.android.app.model.CardCheckoutModel

sealed class DPCheckoutLoadContentState {

    object Loading : DPCheckoutLoadContentState()

    data class Loaded(
        val response: CardCheckoutModel?,
        val selectedDPId: String?,
        val isFreeTrial: Boolean
    ) : DPCheckoutLoadContentState()

    data class Error(
        val error: Throwable,
        val selectedDPId: String?,
        val isFreeTrial: Boolean
    ) : DPCheckoutLoadContentState()
}
