package com.asda.android.app.dp.actionstates

import com.asda.android.restapi.service.data.CheckoutDeliveryPassResponse

sealed class DPCheckoutState {

    object Loading : DPCheckoutState()

    data class Loaded(
        val response: CheckoutDeliveryPassResponse?,
        val dpPromotionId: String?,
        val cardNickname: String?,
        val csc: String?,
        val paRes: String?,
        val autoRenew: Boolean
    ) : DPCheckoutState()

    data class Error(
        val error: Int,
        val response: CheckoutDeliveryPassResponse?
    ) : DPCheckoutState()
}
