package com.asda.android.app.dp.actionstates

import com.asda.android.restapi.service.data.ConfirmDeliveryPassResponse

sealed class DPConfirmOrderState {

    object Loading : DPConfirmOrderState()

    data class Loaded(
        val response: ConfirmDeliveryPassResponse?,
        val cardNickname: String?,
        val csc: String?,
        val paRes: String?,
        val autoRenew: Boolean
    ) : DPConfirmOrderState()

    data class Error(
        val error: Throwable,
        val cardNickname: String?,
        val csc: String?,
        val paRes: String?,
        val autoRenew: Boolean
    ) : DPConfirmOrderState()
}
