package com.asda.android.app.dp.formatter

import com.asda.android.app.dp.model.DeliveryPassItemModel
import com.asda.android.base.core.formatter.IFormatter
import java.util.*

class DPListSortFormatter :
    IFormatter<Array<DeliveryPassItemModel>?, Array<DeliveryPassItemModel>?> {

    override fun format(input: Array<DeliveryPassItemModel>?): Array<DeliveryPassItemModel>? {
        input?.let {
            Arrays.sort(it) { lhs, rhs ->
                when {
                    //Delivery Pass Plus at the top of list so
                    lhs.isDPPlus && rhs.isDPPlus -> 0
                    lhs.isDPPlus -> -1
                    rhs.isDPPlus -> 1
                    else -> when {

                        //for rest of the passes put mid week pass to bottom
                        lhs.isMidWeekDp.equals("true", true)
                              && rhs.isMidWeekDp.equals("true", true) -> 0

                        lhs.isMidWeekDp.equals("true", true) -> 1
                        // then sort by duration in descending order
                        lhs.durationMonths < rhs.durationMonths -> 1
                        lhs.durationMonths > rhs.durationMonths -> -1
                        else -> 0
                    }
                }
            }
        }
        return input
    }
}
