package com.asda.android.app.dp.formatter

import com.asda.android.base.core.formatter.IFormatter
import com.asda.android.utils.Utils
import java.text.SimpleDateFormat
import java.util.*

class DPPromoEndDateFormatter : IFormatter<String?, String?> {
    override fun format(promoEndDate: String?): String? {
        try {
            val dateFormat = SimpleDateFormat("hh:mmaa 'on' dd MMM yyyy", Locale.UK)
            dateFormat.timeZone = Utils.UK.TIME_ZONE
            return dateFormat.format(Date(Utils.getTimeInMillisFromIso(promoEndDate)))
        } catch (e: Exception) {
            return null
        }
    }

}
