package com.asda.android.app.dp.parser

import com.asda.android.app.dp.model.DeliveryPassItemModel
import com.asda.android.base.core.parser.IParser

class DPItemModelPriceParser : IParser<Pair<DeliveryPassItemModel, String>, String?> {

    override fun parse(input: Pair<DeliveryPassItemModel, String>): String? {

        val dpModel = input.first
        val dpId = input.second

        if (dpId.equals(dpModel.oneTimeId, true)) {
            return dpModel.oneTimePrice
        } else if (dpId.equals(dpModel.monthlyId, true)) {
            return dpModel.monthlyPrice
        }
        return null
    }
}
