package com.asda.android.app.dp.view

import android.view.View
import android.view.ViewGroup
import androidx.databinding.BindingAdapter

@BindingAdapter("app:layout_marginTop")
fun setMarginTop(view: View, margin: Float) {
    val marginLayoutParams = view.layoutParams as ViewGroup.MarginLayoutParams
    marginLayoutParams.setMargins(
        marginLayoutParams.leftMargin,
        Math.round(margin),
        marginLayoutParams.rightMargin,
        0
    )
    view.layoutParams = marginLayoutParams
}
