package com.asda.android.app.dp.viewmodel

import android.app.Application
import androidx.lifecycle.AndroidViewModel
import io.reactivex.disposables.CompositeDisposable
import io.reactivex.disposables.Disposable

open class BaseDPViewModel(application: Application) : AndroidViewModel(application) {

    private var compositeDisposable: CompositeDisposable? = null

    init {
        compositeDisposable = CompositeDisposable()
    }

    fun safeAdd(disposable: Disposable?) {
        disposable?.let {
            compositeDisposable?.add(disposable)
        }
    }

    open fun safeDispose() {
        compositeDisposable?.let {
            it.clear()
        }
    }

    override fun onCleared() {
        safeDispose()
        super.onCleared()
    }
}
