package com.asda.android.app.dynamic

import android.os.Bundle
import com.asda.android.R
import com.asda.android.app.shop.productdetail.view.ProductManager
import com.asda.android.base.core.view.actitivies.BaseAppCompatActivity
import com.asda.android.base.core.view.fragments.BaseFragment

class LinkSaveDynamicPageRecipeActivity : BaseAppCompatActivity() {

    companion object {
        const val PROMO_ID = "promo_id"
    }

    private var mPromoId: String? = null

    override fun getFragmentContainer() = R.id.fragment_container

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.fragment_container)
        getArguments()

        supportActionBar?.title = ""
        supportActionBar?.setDisplayHomeAsUpEnabled(true)

        val fragment = getLinkSaveFragment()
        fragment?.let {
            push(it)
        }
    }

    private fun getLinkSaveFragment(): BaseFragment? {
        return if (!mPromoId.isNullOrBlank())
            ProductManager.getLinkSaveFragment(this, mPromoId)
        else
            null
    }

    private fun getArguments() {
        intent?.data?.let {
            mPromoId = it.getQueryParameter(PROMO_ID)
        }
    }
}
