package com.asda.android.app.home

import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.databinding.ViewDataBinding
import com.asda.android.R
import com.asda.android.app.model.WismoCardModel
import com.asda.android.base.core.utils.tryCast
import com.asda.android.base.interfaces.IWismoManager
import com.asda.android.databinding.HomeCardWismoNewBinding
import com.asda.android.restapi.service.data.ViewOrderResponse

class WismoManager : IWismoManager {
    override fun setUpWismo(order: ViewOrderResponse.Order, container: ViewGroup) {
        DataBindingUtil.inflate<ViewDataBinding>(LayoutInflater.from(container.context), R.layout.home_card_wismo_new, container, true).apply {
            tryCast<HomeCardWismoNewBinding> {
                viewModel = WismoCardModel(container.context, order)
            }
        }
    }
}
