package com.asda.android.app.home.validator

import com.asda.android.base.core.validator.IValidator

import com.asda.android.singleprofile.api.model.ProfileResponse
import com.asda.android.singleprofile.validator.TncValidator

class ProfileResponseValidator(serviceId: String?) : IValidator<ProfileResponse?> {
    private val tncValidator: TncValidator? = serviceId?.let { TncValidator(it) }


    @Throws(RuntimeException::class)
    override fun validate(t: ProfileResponse?): Boolean {
        if (tncValidator?.validate(t) == false) {
            throw TncValidatorException()
        }
        return true
    }
}
