package com.asda.android.app.main.view

import android.content.Intent
import android.os.Bundle
import android.os.Handler
import androidx.appcompat.app.AppCompatActivity
import com.asda.android.R
import com.asda.android.app.main.AsdaApplication

class SPAActivity : AppCompatActivity() {

    private val REFRESH_TIME = 60000L
    private val handler = Handler()
    private var runnable : Runnable ?= null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContentView(R.layout.asda_spa_page)

        runnable = Runnable {
            relaunchApp()
        }

        handler.postDelayed(runnable, REFRESH_TIME)

    }

    private fun relaunchApp() {
        val intent = Intent(this, AsdaActivity::class.java)
        intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
        AsdaApplication.getInstance()?.startActivity(intent)
    }

    override fun onRestart() {
        super.onRestart()
        relaunchApp()
    }

    override fun onPause() {
        handler.removeCallbacks(runnable)
        super.onPause()
    }
}
