package com.asda.android.app.recurringslot

import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.MenuItem
import android.view.View
import android.view.ViewGroup
import com.asda.android.R
import com.asda.android.analytics.constants.Anivia
import com.asda.android.analytics.events.PageViewEvent
import com.asda.android.app.account.view.AccountFragment
import com.asda.android.app.account.view.BaseAccountActivity
import com.asda.android.app.bookslotv3.view.activity.BookSlotActivity
import com.asda.android.app.dp.view.DeliveryPassPurchaseActivity
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.base.core.view.fragments.FeaturedFragment


class RecurringSlotInfoFragment : FeaturedFragment() {

    override fun onAttach(context: Context) {
        super.onAttach(context)
        pageViewEvent = PageViewEvent(Anivia.PV_RECURRING_SLOT_INFO, Anivia.SECTION_ACCOUNT)
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        return inflater.inflate(R.layout.recurring_slots_help, container, false)
    }

    override fun hasActionBar(): Boolean {
        val activity = activity
        return (activity is AsdaActivity || activity is BookSlotActivity || activity is DeliveryPassPurchaseActivity
                || activity is BaseAccountActivity || parentFragment is AccountFragment)
    }

    override fun getActionBarTitle(): String? {
        return if (activity != null) getString(R.string.recurring_slot_info_title) else ""
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        if (item.itemId == android.R.id.home) {
            pop()
            return true
        }
        return false
    }

    override fun getInternalTag(): String? {
        return TAG
    }

    companion object {

        const val TAG = "RecurringSlotInfoFragment"

        fun newInstance(): RecurringSlotInfoFragment {
            return RecurringSlotInfoFragment()
        }
    }
}
