package com.asda.android.app.recurringslot.module.view.adapters

import android.content.Context
import android.widget.TextView
import android.view.ViewGroup
import android.view.View
import android.widget.ArrayAdapter
import androidx.core.content.ContextCompat
import com.asda.android.R
import com.asda.android.base.core.DateFormats
import com.asda.android.base.core.convertToFormat
import com.asda.android.restapi.service.data.recurringslots.SlotSuggestedDay


class DateSpinnerAdapter(context: Context, textViewResourceId: Int, val values: List<SlotSuggestedDay>) : ArrayAdapter<SlotSuggestedDay>(context, textViewResourceId, values) {

    override fun getCount(): Int {
        return values.size
    }

    override fun getItem(position: Int): SlotSuggestedDay? {
        return values[position]
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }


    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {
        val label = super.getView(position, convertView, parent) as TextView
        label.setTextColor(ContextCompat.getColor(context, R.color.text))
        label.text = values[position].slot_date?.convertToFormat(DateFormats.YYYY_MM_DD_T_HH_MM_SS_Z, DateFormats.EEEE_DD_MMM)

        return label
    }

    override fun getDropDownView(position: Int, convertView: View?,
                                 parent: ViewGroup): View {
        val label = super.getDropDownView(position, convertView, parent) as TextView
        label.setTextColor(ContextCompat.getColor(context, R.color.text))
        label.text = values[position].slot_date?.convertToFormat(DateFormats.YYYY_MM_DD_T_HH_MM_SS_Z, DateFormats.EEEE_DD_MMM)

        return label
    }
}
