package com.asda.android.app.recurringslot.module.view.adapters

import android.content.Context
import android.widget.TextView
import android.view.ViewGroup
import android.view.View
import android.widget.ArrayAdapter
import androidx.core.content.ContextCompat
import com.asda.android.R
import com.asda.android.base.core.DateFormats
import com.asda.android.base.core.convertToFormat
import com.asda.android.restapi.service.data.recurringslots.SlotsSuggested


class DaySpinnerAdapter(context: Context, textViewResourceId: Int, val values: List<SlotsSuggested>) : ArrayAdapter<SlotsSuggested>(context, textViewResourceId, values) {

    override fun getCount(): Int {
        return values.size
    }

    override fun getItem(position: Int): SlotsSuggested? {
        return values[position]
    }

    override fun getItemId(position: Int): Long {
        return position.toLong()
    }

    override fun getView(position: Int, convertView: View?, parent: ViewGroup): View {
        val label = super.getView(position, convertView, parent) as TextView
        label.setTextColor(ContextCompat.getColor(context, R.color.text))
        label.text = context.getString(R.string.rs_from_to_hour, values[position].slotInfo?.start_time?.convertToFormat(DateFormats.YYYY_MM_DD_T_HH_MM_SS_Z, DateFormats.H_MM_AA), values[position].slotInfo?.end_time?.convertToFormat(DateFormats.YYYY_MM_DD_T_HH_MM_SS_Z, DateFormats.H_MM_AA))

        return label
    }

    override fun getDropDownView(position: Int, convertView: View?,
                                 parent: ViewGroup): View {
        val label = super.getDropDownView(position, convertView, parent) as TextView
        label.setTextColor(ContextCompat.getColor(context, R.color.text))
        label.text = context.getString(R.string.rs_from_to_hour, values[position].slotInfo?.start_time?.convertToFormat(DateFormats.YYYY_MM_DD_T_HH_MM_SS_Z, DateFormats.H_MM_AA), values[position].slotInfo?.end_time?.convertToFormat(DateFormats.YYYY_MM_DD_T_HH_MM_SS_Z, DateFormats.H_MM_AA))

        return label
    }

}
