package com.asda.android.app.shop

import androidx.annotation.VisibleForTesting
import androidx.lifecycle.ViewModel
import com.asda.android.restapi.service.base.AsdaServiceImpl
import com.asda.android.restapi.service.data.CustomNutritionFilter
import com.asda.android.restapi.service.data.CustomNutritionFilterResponse
import com.asda.android.restapi.service.data.EditCustomNutritionFilter
import com.asda.android.service.base.AsdaServiceFactory
import io.reactivex.Observable


class CustomFiltersViewModel : ViewModel() {

    fun createCustomFilter(filterName: String, filterItems: Array<CustomNutritionFilter.FilterItem>): Observable<CustomNutritionFilterResponse> {
        val customNutritionFilter = CustomNutritionFilter()
        customNutritionFilter.filterName = filterName
        customNutritionFilter.filterItems = filterItems
        return getService().createCustomNutritionFilter(customNutritionFilter)
    }

    fun editFilters(filterName: String, oldFilterName: String, filters: Array<CustomNutritionFilter.FilterItem>): Observable<CustomNutritionFilterResponse> {
        val editCustomNutritionFilter = EditCustomNutritionFilter()
        editCustomNutritionFilter.filterName = filterName
        editCustomNutritionFilter.oldFilterName = oldFilterName
        editCustomNutritionFilter.filterItems = filters
        return getService().editCustomNutritionFilter(editCustomNutritionFilter)
    }


    fun deleteFilter(filterName: String): Observable<CustomNutritionFilterResponse> {
        return getService().deleteCustomNutritionFilter(filterName)
    }

    @VisibleForTesting
    fun getService(): AsdaServiceImpl {
        return AsdaServiceFactory.get()
    }
}
