package com.asda.android.app.shop.addtotrolley.repository

import androidx.lifecycle.MutableLiveData
import com.asda.android.base.core.response.BaseStateResponse
import com.asda.android.restapi.service.data.cart.CartResponse
import com.asda.android.service.repository.CartRepository
import io.reactivex.SingleObserver
import io.reactivex.disposables.Disposable

class AddToTrolleyRepository {

    val cartResponseLiveData: MutableLiveData<BaseStateResponse<CartResponse>> = MutableLiveData()

    fun addUpdateCart(cartRepository: CartRepository, items: ArrayList<Any>) {
        cartRepository.addUpdateShoppingList(items)
              ?.subscribe(object : SingleObserver<Any> {
                  override fun onSuccess(t: Any) {
                      cartResponseLiveData.postValue(BaseStateResponse(t as CartResponse));
                  }

                  override fun onSubscribe(d: Disposable) {
                      //This method is not implemented as there is no operation to be performed in onSubscribe()
                  }

                  override fun onError(e: Throwable) {
                      cartResponseLiveData.postValue(BaseStateResponse(e));
                  }
              })

    }
}
