package com.asda.android.app.shop.addtotrolley.viewmodel

import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import com.asda.android.app.shop.addtotrolley.repository.AddToTrolleyRepository
import com.asda.android.base.core.response.BaseStateResponse
import com.asda.android.restapi.service.data.cart.CartResponse
import com.asda.android.service.repository.CartRepository

class AddToTrolleyViewModel : ViewModel() {

    var repository: AddToTrolleyRepository
    var cartRepository: CartRepository
    lateinit var items: ArrayList<Any>

    init {
        repository = setAddToTrolleyRepository()
        cartRepository = setCartRepository()
    }

    fun updateCart() {
        repository.addUpdateCart(cartRepository, items)
    }

    fun getCartResponseLiveData(): MutableLiveData<BaseStateResponse<CartResponse>> {
        return repository.cartResponseLiveData
    }

    fun setAddToTrolleyRepository(): AddToTrolleyRepository {
        return AddToTrolleyRepository()
    }

    fun setCartRepository(): CartRepository {
        return CartRepository()
    }

    fun setItemstoBeAdded(itemList: ArrayList<Any>) {
        items = itemList;

    }
}

