package com.asda.android.app.shop.taxonomy.formatter

import com.asda.android.taxonomy.features.taxonomy.model.IEvent
import com.asda.android.taxonomy.features.taxonomy.model.TaxonomyEventInfo
import com.asda.android.app.shop.taxonomy.model.TaxonomyIdFormatterModel
import com.asda.android.taxonomy.features.taxonomy.model.TaxonomyP13NInfoModel
import com.asda.android.app.shop.taxonomy.repository.TaxonomyRemoteRepository
import com.asda.android.base.core.formatter.IFormatter

class EventFormatterProvider(private val dataSource: TaxonomyRemoteRepository) : IFormatter<IEvent, Unit> {
    private val taxonomyLevelFormatter = TaxonomyLevelFormatter()
    private val taxonomyIdFormatter = TaxonomyIdFormatter()
    override fun format(input: IEvent) {
        if (input is TaxonomyEventInfo) {
            input.analyticsTaxonomy = taxonomyLevelFormatter.format(input.catType)
        }
        if (input is TaxonomyP13NInfoModel) {
            input.taxonomyId = taxonomyIdFormatter.format(TaxonomyIdFormatterModel(dataSource.ancestorRepository.ancestors, input.catType, input.dimesionId, input.prefix))
        }
    }

}
