package com.asda.android.app.shop.taxonomy.formatter

import com.asda.android.restapi.service.data.cms.Refinement

class RefinementTypeComparator : Comparator<Refinement> {
    private val taxonomyTypeArr = arrayOf(Refinement.TYPE_CAT, Refinement.TYPE_DEPT, Refinement.TYPE_AISLE, Refinement.TYPE_SHELF)

    override fun compare(a: Refinement?, b: Refinement?): Int {
        return if (a == null && b == null) {
            0
        } else if (a?.properties == null) {
            -1
        } else if (b?.properties == null) {
            1
        } else {
            compareTaxonomyType(a.properties!!.categoryType, b.properties!!.categoryType)
        }
    }

    private fun compareTaxonomyType(taxonomyType1: String?, taxonomyType2: String?): Int {
        var index1 = taxonomyTypeArr.indexOf(taxonomyType1)
        if (index1 < 0) {
            index1 = Int.MAX_VALUE
        }
        var index2 = taxonomyTypeArr.indexOf(taxonomyType2)
        if (index2 < 0) {
            index2 = Int.MAX_VALUE
        }
        return compareValues(index1, index2)
    }

}
