package com.asda.android.app.shop.taxonomy.formatter

import com.asda.android.base.core.formatter.IFormatter
import com.asda.android.restapi.service.data.cms.Refinement

class TaxonomyLevelFormatter : IFormatter<String?, String> {
    override fun format(input: String?): String {
        input?.let { taxonomyType ->
            return when (taxonomyType) {
                Refinement.TYPE_AISLE -> "aisle"
                Refinement.TYPE_DEPT -> "department"
                Refinement.TYPE_CAT -> "category"
                Refinement.TYPE_SHELF -> "shelf"
                else -> taxonomyType
            }
        }
        return ""
    }
}
