package com.asda.android.app.shop.taxonomy.parser

import com.asda.android.base.core.parser.IParser
import com.asda.android.restapi.service.data.cms.Refinement

class AncestorDimensionIdParser : IParser<List<Refinement>, List<String>> {
    private val dimensionIdParser = DimensionIdParser()
    override fun parse(input: List<Refinement>): List<String> {
        val dimensionIdList = mutableListOf<String>()
        input.forEach { refinement ->
            val dimensionId = dimensionIdParser.parse(refinement.dimensionId)
            if(dimensionId.isNotEmpty()){
                dimensionIdList.add(dimensionId)
            }
        }
        return dimensionIdList
    }

}
