package com.asda.android.app.shop.taxonomy.parser

import com.asda.android.restapi.app.dynamic.ContentHandler
import com.asda.android.restapi.service.data.cms.AsdaBreadCrumbs
import com.asda.android.restapi.service.data.cms.AsdaFacetFilterOffers
import com.asda.android.restapi.service.data.cms.Content
import com.asda.android.restapi.service.data.cms.Refinement

class RefinementAncestorHandler : ContentHandler {
    val refinementList = mutableListOf<Refinement>()
    var label : String? = null
    override fun handleContent(content: Content?) {
        refinementList.clear()
        label = null
        if (content is AsdaBreadCrumbs) {
            if(label == null) {
                label = content.refinementCrumbs?.first()?.shelfName
            }
            content.refinementCrumbs?.let {
                it.forEach { refinementBreadcrumb ->
                    refinementBreadcrumb.ancestors?.forEach { refinement ->
                        refinementList.add(refinement)
                    }
                }
            }
        } else if (content is AsdaFacetFilterOffers) {
            content.ancestors?.forEach { refinement ->
                refinementList.add(refinement)
            }
        }
    }
}
