package com.asda.android.app.shop.taxonomy.repository

import androidx.annotation.VisibleForTesting
import com.asda.android.analytics.constants.Anivia
import com.asda.android.analytics.events.ApiErrorEvent
import com.asda.android.app.shop.taxonomy.model.APIErrorEventModel
import com.asda.android.restapi.service.base.IAuthentication
import com.asda.android.service.base.Authentication
import com.asda.android.taxonomy.features.taxonomy.repository.BaseTaxonomyRepository

class ApiErrorTrackerRepository : BaseTaxonomyRepository() {
    fun execute(event: APIErrorEventModel) {
        val errorEvent = ApiErrorEvent.createResponseEvent(event.apiEndPoint
              ?: "", event.errorCode, event.errorMessage
              ?: "", System.currentTimeMillis().toString(), getPageName(event), event.errorMessage
              ?: "")
        errorEvent.putString(Anivia.CUSTOMER_ID_KEY, getAuthentication()?.profileId ?: "")
        getTracker().trackEvent(errorEvent)
    }

    fun getAuthentication(): IAuthentication? {
        return Authentication.getInstance()
    }

    @VisibleForTesting
    fun getPageName(event: APIErrorEventModel): String {
        return event.analyticsTaxonomy + " : " + event.atomicTaxonomy
    }
}
