package com.asda.android.app.shop.taxonomy.repository

import androidx.annotation.VisibleForTesting
import com.asda.android.app.dynamic.manager.ContentManager
import com.asda.android.app.shop.taxonomy.model.GetAncestorEvent
import com.asda.android.app.shop.taxonomy.parser.RefinementAncestorHandler
import com.asda.android.restapi.service.data.cms.Refinement

class GetAncestorRepository {
    @VisibleForTesting
    val ancestorParser = RefinementAncestorHandler()

    var label: String? = null
        private set
    var ancestors: List<Refinement>? = null
        private set
    fun execute(event: GetAncestorEvent) {
        ContentManager.produce(ancestorParser, event.content)
        ancestors = ancestorParser.refinementList
        label = ancestorParser.label
    }

}
