package com.asda.android.app.shop.topoffers.viewmodel

import com.asda.android.analytics.constants.Anivia.CATEGORY_MERCH_SPECIAL_TOP_OFFERS
import com.asda.android.taxonomy.features.taxonomy.model.TaxonomyPageEventModel
import com.asda.android.app.shop.taxonomy.viewmodel.TaxonomyViewModel
import com.asda.android.restapi.service.data.cms.Content
import com.asda.android.restapi.service.data.cms.Content.checkArray
import com.asda.android.restapi.service.data.cms.Personalization
import com.asda.android.restapi.service.data.cms.Refinement


class TopOffersViewModel : TaxonomyViewModel() {

    var loaderInProgress: Boolean = true
    var responseInProgress: Boolean = true
    val pageEventModel = TaxonomyPageEventModel()
    val category = Refinement.TYPE_SPECIAL_OFFERS

    fun updatePersonalizationContents(contents: Array<Content>): Boolean {
        var isUpdated = false
        if (checkArray(contents)) {
            for (content in contents) {
                if (content is Personalization) {
                    isUpdated = true
                    content.trackingCode = CATEGORY_MERCH_SPECIAL_TOP_OFFERS
                    content.viewInfo.isHorizontal = false
                    content.viewInfo.isShowTitle = false
                }
            }
        }
        return isUpdated
    }

    companion object {
        val taxonomyName = "special offers > top offers"
    }

}
