package com.asda.android.app.view

import android.os.Bundle
import android.view.LayoutInflater
import android.view.MenuItem
import android.view.View
import android.view.ViewGroup
import com.asda.android.R
import com.asda.android.app.base.FragmentConfig
import com.asda.android.app.main.view.AsdaActivity
import com.asda.android.restapi.search.model.AsdaSearchData
import com.asda.android.app.shop.ShopFragment

class BaseSearchFragment : SearchableFragment() {
    var currentView: View? = null

    override fun onCreateView(inflater: LayoutInflater, fragmentContainer: ViewGroup?, savedInstanceState: Bundle?): View {
        if (currentView == null) {
            currentView = inflater.inflate(R.layout.no_content_container, fragmentContainer, false)

        }
        return currentView!!
    }

    override fun onSearchRequested(searchData: AsdaSearchData) {
        super.onSearchRequested(searchData)
        popToRoot()
        val bundle = Bundle().apply {
            putParcelable(ShopFragment.ARG_SEARCH_DATA, searchData)
        }
        (activity as? AsdaActivity)?.fragmentSwitcher?.switchToFragment(FragmentConfig.TAG_SHOP, bundle)
    }

    override fun onOptionsItemSelected(item: MenuItem): Boolean {
        finishSearchAction()
        return super.onOptionsItemSelected(item)
    }

    override fun onBackPressed(): Boolean {
        finishSearchAction()
        return super.onBackPressed()
    }
}
