package com.asda.android.service.base

import android.util.Log
import com.asda.android.base.core.listener.ITypedListener

/**
 * base class for add cart change info logger
 */
abstract class BaseCartChangeInfoLogger<T> : ITypedListener<T> {
    private val TAG = "BaseCartChangeInfo"
    override fun post(data: T): Boolean {

        try {
            val isDataValidToPost = isValid(data)
            if (!isDataValidToPost) {
                return isDataValidToPost
            }
            return postData(data)

        } catch (ex: Exception) {
            Log.e(TAG, "Exception while sending cart add impression - $ex")
            return false
        }

    }

    abstract fun postData(data: T): Boolean
}
