package com.asda.android.utils

import android.content.Context
import com.asda.android.analytics.Tracker
import com.asda.android.analytics.events.exception.CaughtExceptionEvent
import com.asda.android.app.settings.featureflag.FeatureSettings
import com.google.firebase.perf.FirebasePerformance
import com.google.firebase.perf.metrics.Trace

object FirebasePerformanceTracker {

    fun startTrace(context: Context, tag: String) : Trace? {
        var trace : Trace? = null
        if (FeatureSettings.isFirebasePerformanceEnabled(context)) {
            try {
                trace = FirebasePerformance.getInstance().newTrace(tag)
                trace.start()
            } catch (ex : Exception) {
                Tracker.get().trackException(CaughtExceptionEvent(ex))
            }
        }
        return trace
    }

    fun stopTrace(trace : Trace?) {
        try {
            trace?.stop()
        } catch (ex  :Exception) {
            Tracker.get().trackException(CaughtExceptionEvent(ex))
        }
    }
}


