package com.asda.giftcard

import android.content.Context
import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.ImageView
import android.widget.TextView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.RecyclerView
import com.asda.android.R
import com.asda.android.imageloader.ImageLoader
import com.asda.android.imageloader.ImageLoaderRequest
import com.asda.android.restapi.service.data.CheckoutResponse
import kotlinx.android.synthetic.main.gift_card_restricted_item.view.*

class GiftCardRestrictedItemAdapter(val context: Context, var items: List<CheckoutResponse.Message.DelistedItem>) : RecyclerView.Adapter<GiftCardRestrictedItemAdapter.RestrictedItemViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RestrictedItemViewHolder {
        return RestrictedItemViewHolder(LayoutInflater.from(context).inflate(R.layout.gift_card_restricted_item, parent, false))
    }

    override fun onBindViewHolder(holder: RestrictedItemViewHolder, position: Int) {
        items[position].imageURL?.let {
            ImageLoader.load(holder.itemImage?.context, holder.itemImage!!, ImageLoaderRequest.Builder().path(it).build())
        } ?: run { context?.let{
            holder.itemImage?.setImageDrawable(ContextCompat.getDrawable(context, R.drawable.ic_truck))
        } }
        holder.itemName?.text = items[position].name
        holder.itemPrice?.text = items[position].price
        holder.restrictedtext?.visibility =View.VISIBLE
    }

    override fun getItemCount(): Int {
        return items.size
    }

    class RestrictedItemViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        var itemImage: ImageView? = itemView.findViewById(R.id.item_image)
        var itemName: TextView? = itemView.findViewById(R.id.item_name)
        var itemPrice: TextView? = itemView.findViewById(R.id.item_price)
        var restrictedtext: TextView? = itemView.findViewById(R.id.restricted_text)
    }

    fun updateData(data: MutableList<CheckoutResponse.Message.DelistedItem>) {
        items = data
        notifyDataSetChanged()
    }

}
