package com.asda.giftcard.view

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.asda.android.R
import com.asda.android.restapi.service.data.WismoOrderResponse
import com.asda.giftcard.GiftCardUtils

class GiftCardDetailsListAdapter (val context: Context, var giftCards: List<WismoOrderResponse.GiftCardPayment>) : RecyclerView.Adapter<GiftCardDetailsListAdapter.GiftCardDetailsViewHolder>() {
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): GiftCardDetailsViewHolder {
        return GiftCardDetailsViewHolder(LayoutInflater.from(context).inflate(R.layout.order_history_gift_card_details_item_view, parent, false))
    }

    override fun getItemCount(): Int {
        return giftCards.size
    }

    override fun onBindViewHolder(holder: GiftCardDetailsViewHolder, position: Int) {
        holder.giftCardNumber?.text = GiftCardUtils.formatGiftCardNumber(giftCards[position].gcNum.toString())
        holder.giftCardPin?.text = giftCards[position].panelCode
    }

    class GiftCardDetailsViewHolder(giftCardDetailView: View) : RecyclerView.ViewHolder(giftCardDetailView) {
        var giftCardNumber: TextView? = giftCardDetailView.findViewById(R.id.order_gift_card_number)
        var giftCardPin: TextView? = giftCardDetailView.findViewById(R.id.order_gift_card_panel_code)
    }
}
