package com.asda.android.lastmile.carcolor.view


import android.content.DialogInterface
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.DialogFragment
import com.asda.android.R
import com.asda.android.utils.view.ViewUtil

class CarColorDialogFragment : DialogFragment() {

    private var listener: CarColorAdapter.OnCarColorSelected? = null
    private var adapter: CarColorAdapter? = null

    fun setOnCarColorSelected(listener: CarColorAdapter.OnCarColorSelected?) {
        this.listener = listener
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        val dialogView = inflater.inflate(R.layout.car_color_dialog, container, false)
        val recyclerView = ViewUtil.findViewById<androidx.recyclerview.widget.RecyclerView>(dialogView, R.id.recyclerView)
        recyclerView.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(activity)
        adapter = CarColorAdapter(activity, true)
        adapter?.setOnCarColorSelected(listener)
        recyclerView.adapter = adapter
        return dialogView
    }

    companion object {
        fun newInstance(): CarColorDialogFragment {
            return CarColorDialogFragment()
        }
    }

    override fun onDismiss(dialog: DialogInterface) {
        super.onDismiss(dialog)
        //Remove ref
        destroy()
    }

    private fun destroy() {
        listener = null
        adapter?.destroy()
        adapter = null
    }
}
