package com.asda.lastmile.mock

import com.facebook.litho.Column
import com.facebook.litho.ComponentContext
import com.facebook.litho.ComponentLayout
import com.facebook.litho.annotations.LayoutSpec
import com.facebook.litho.annotations.OnCreateLayout
import com.facebook.litho.annotations.Prop
import com.facebook.litho.widget.Text
import com.facebook.yoga.YogaEdge

@LayoutSpec
object CheckinEligibilityStatusSpec {

    @OnCreateLayout
    internal fun onCreateLayout(c: ComponentContext,
                                @Prop isCheckinElegible: Boolean,
                                @Prop index: Int,
                                @Prop(optional = true) checkinStateChgListener: ((Int, Boolean?) -> Unit)?): ComponentLayout {

        return Column.create(c)
                .paddingDip(YogaEdge.ALL, 16f)
                .child(
                        Text.create(c)
                                .text("Checkin Eligibility")
                                .widthDip(200f)
                                .textSizeSp(14f))
                .child(
                        CheckinEligibilityRadioGroup.create(c)
                                .isCheckinEligible(isCheckinElegible)
                                .checkinStateChgListener(checkinStateChgListener)
                                .index(index)
                                .heightDip(60f)
                )
                .build()
    }
}
