package com.asda.lastmile.mock

import android.os.Bundle
import androidx.appcompat.app.AppCompatActivity
import com.asda.android.service.base.OrderManager
import com.asda.android.restapi.service.data.ViewOrderResponse
import com.facebook.litho.ComponentContext
import com.facebook.litho.LithoView
import com.facebook.litho.sections.SectionContext
import com.facebook.litho.sections.widget.RecyclerCollectionComponent

class MockLastMileOrdersActivity : AppCompatActivity() {

    var orderList: List<ViewOrderResponse.Order>? = null

    var listener: ((Int, String) -> Unit)? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        val lithoView: LithoView?

        val orderManager = OrderManager.get()
        orderList = orderManager.orders
        val c = ComponentContext(this)

        listener = fun(index, status) {
            orderList!!.get(index).orderStatus = status
        }


        if (orderList?.size != 0) {
            val listComponent =
                    RecyclerCollectionComponent.create(c)
                            .disablePTR(true)
                            .section(OrderItemListSection.create(SectionContext(c))
                                    .orderList(orderList!!)
                                    .orderStateChglistener (listener)
                                    .checkinStateChgListener { index, check ->
                                        orderList!!.get(index).isCheckinEligible = check
                                    }
                                    .build())
                            .build()
            lithoView = LithoView.create(c, listComponent)
            setContentView(lithoView)
        } else {
            val textComponent = EmptyOrders.create(c)
                    .title("Login with valid account and the come back to this screen to modify the existing orders!!!")
                    .build()

            val lithoViewWarning = LithoView.create(c, textComponent)
            setContentView(lithoViewWarning)
        }

    }

    override fun onPause() {
        super.onPause()
        if (orderList?.size != 0) {
            OrderManager.get().setModifiedOrders(orderList)
        }
    }
}
