package com.asda.lastmile.parkingspot.view

import android.content.DialogInterface
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.DialogFragment
import com.asda.android.R
import com.asda.android.utils.view.ViewUtil

class ParkingSpotDialogFragment : DialogFragment() {

    private var listener: ParkingSpotAdapter.OnParkingSpotSelected? = null
    private var adapter: ParkingSpotAdapter? = null

    fun setOnParkingSpotSelected(listener: ParkingSpotAdapter.OnParkingSpotSelected?) {
        this.listener = listener
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View {
        val dialogView = inflater.inflate(R.layout.parking_spot_dialog, container, false)
        val recyclerView = ViewUtil.findViewById<androidx.recyclerview.widget.RecyclerView>(dialogView, R.id.recyclerView)
        recyclerView.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(activity)
        adapter = ParkingSpotAdapter(activity, true)
        adapter?.setOnParkingSpotSelected(listener)
        recyclerView.adapter = adapter
        return dialogView
    }

    companion object {
        fun newInstance(): ParkingSpotDialogFragment {
            return ParkingSpotDialogFragment()
        }
    }

    override fun onDismiss(dialog: DialogInterface) {
        super.onDismiss(dialog)
        //Remove ref
        destroy()
    }

    private fun destroy() {
        listener = null
        adapter?.destroy()
        adapter = null
    }
}
