package com.asda.recipes.adapters.controllers

import android.content.Context
import androidx.annotation.VisibleForTesting
import com.airbnb.epoxy.EpoxyModel
import com.asda.android.app.shop.ShelfDynamicSectionLoader
import com.asda.android.recipes.controllers.SearchRecipePagedListController
import com.asda.recipes.adapters.models.CmsContentEpoxyModel_

class NonCuratedRecipePagedListController(context: Context): SearchRecipePagedListController(context, false) {
    @VisibleForTesting
    var dynamicLoader: ShelfDynamicSectionLoader? = null

    fun addDynamicSection(loader: ShelfDynamicSectionLoader) {
        dynamicLoader = loader
        requestModelBuild()
    }

    override fun addModels(models: List<EpoxyModel<*>>) {
        dynamicLoader?.let {
            super.addModels(models.toMutableList().apply {
                this.add(0, CmsContentEpoxyModel_()
                        .id("cms")
                        .loader(it))
            })
        } ?: run {
            super.addModels(models)
        }
    }
}
