package com.asda.recipes.adapters.models

import android.view.View
import com.airbnb.epoxy.EpoxyAttribute
import com.airbnb.epoxy.EpoxyHolder
import com.airbnb.epoxy.EpoxyModelClass
import com.airbnb.epoxy.EpoxyModelWithHolder
import com.asda.android.R
import com.asda.android.app.shop.ShelfDynamicSectionLoader
import com.facebook.litho.LithoView

@EpoxyModelClass
abstract class CmsContentEpoxyModel: EpoxyModelWithHolder<CmsContentEpoxyModel.CmsContentItemHolder>() {
    @EpoxyAttribute
    var loader: ShelfDynamicSectionLoader? = null

    override fun getDefaultLayout(): Int = R.layout.dynamic_section

    override fun bind(holder: CmsContentItemHolder) {
        loader?.let {
            holder.view.visibility = View.VISIBLE
            it.bindContent(holder.view)
        }
    }

    inner class CmsContentItemHolder: EpoxyHolder() {
        lateinit var view: LithoView

        override fun bindView(itemView: View) {
            view = itemView as LithoView
        }
    }
}
